(* ------------------------------------------------------ *)
(*                   TEXTDEMO.PAS                         *)
(* Beispielprogramm fr die Verwendung von TEXTVERL.INC   *)
(*      (c) 1989 by Wolfgang Dexheimer und TOOLBOX        *)
(* ------------------------------------------------------ *)
PROGRAM TextDemo;

USES Crt;

TYPE
  FName = STRING(.14.);
  Str60 = STRING(.60.);

VAR
  TF, ATF     : TEXT;
  Name, AName : FName;
  ch          : CHAR;
  Eingabe     : STRING(.255.);

{$I TEXTVERL.INC}

  PROCEDURE Datei_Name_Lesen(welcher   : Str60;
                             pruefen   : BOOLEAN;
                             VAR DName : FName);
  BEGIN
    Write(welcher, ' : ');  ReadLn(DName);
    IF Pos('.', welcher) = 0 THEN DName := DName + '.TXT';
    IF pruefen THEN BEGIN
      Assign(ATF, DName);
      {$I-} Reset(ATF); {$I+}
      IF IOResult <> 0 THEN BEGIN
        WriteLn;
        WriteLn('Die Datei ', DName,
                ' kann ich nicht finden !!');
        DName := '';
        WriteLn('      -> weiter mit bel. Taste <-');
        REPEAT UNTIL KeyPressed;
      END;
    END;
  END;

BEGIN
  REPEAT
    ClrScr;
    WriteLn; WriteLn; WriteLn;
    WriteLn; WriteLn; WriteLn;
    WriteLn('Beispielprogramm fr die Verwendung von ',
            'TEXTVERL.INC':66);
    WriteLn; WriteLn;
    WriteLn('1 = TEXT-File anfgen':45);
    WriteLn;
    WriteLn('2 = Eingabe von Tastatur anfgen':56);
    WriteLn;
    WriteLn('E = ENDE':32);
    WriteLn; WriteLn;
    Write('Bitte whlen Sie -> ':24);
    REPEAT
      ch := ReadKey;
      ch := UpCase(ch);
    UNTIL ch IN (.'1', '2', 'E'.);
    WriteLn(ch); WriteLn;
    IF ch <> 'E' THEN
      Datei_Name_LeseN('Name der Datei ', FALSE, Name);
    CASE ch OF
      '1' : BEGIN
              Datei_Name_Lesen('Name der Datei ',
                                TRUE, AName);
              IF Length(AName) > 0 THEN BEGIN
                Text_File_VerL(Name);
                WHILE NOT EOF(ATF) DO BEGIN
                  ReadLn(ATF, Eingabe);
                  WriteLn(TF, Eingabe);
                END;
                Close(ATF); Close(TF);
              END;
            END;
      '2' : BEGIN
              Text_File_VerL(Name);
              REPEAT
                WriteLn;
                Write('Eingabe (.E. = ENDE): ');
                ReadLn(Eingabe);
                IF Eingabe <> '.E.' THEN
                  WriteLn(TF, Eingabe);
              UNTIL Eingabe = '.E.';
              Close(TF);
            END;
    END;
  UNTIL ch = 'E';
END.
(* ------------------------------------------------------ *)
(*                Ende von TEXTDEMO.PAS                   *)